! Time-stamp: <2010-11-08 10:24:56 guenter>
! smslabel.prg
!
define/para p1 {smsresult}.bdf I/C
define/para p2 "normalized flux" ?
! 
if p1 .eq. "-h" then
   @@ sms/help/labelhelp.prg
   return
endif

define/local file/c/1/40 " "
define/local oldplg/r/1/40  0.  all
define/local eqline/c/1/10  " " All
define/local deqline/c/1/15 " " All
define/local fsize/r/1/1 1.0
define/local lcoord/d/1/2 0.,0.
define/local lstep/d/1/1 0.05
define/local ylabel/c/1/20 "normalized flux" 

set/midas output={smsverb} newfiles=midas

delete/display {smsdisplaynum} >/dev/null

if m$exist("{p1}") .eq. 0 inquire/keyword p1 "{labelfileask}: "

if p2 .ne. ylabel  ylabel = "{p2}"

weiter:
if m$exist("{p1}") .eq. 0 then
   write/sms "{notfound}"
   return
endif

set/graph pm=0
plot/row {p1}
copy/keyw plrgrap oldplg

inquire/keyw smsobject "{objectask} [{smsobject}]: "
if {aux_mode(7)} .gt. 0 smsobject = smsobject(1:{aux_mode(7)})
inquire/keyw smsobserver "{obsask} [{smsobserver}]: "
if {aux_mode(7)} .gt. 0 smsobserver = smsobserver(1:{aux_mode(7)})
inquire/keyw smsownstring "{ownstringask} [{smsownstring}]: "
if {aux_mode(7)} .gt. 0 smsownstring = smsownstring(1:{aux_mode(7)})

L$L$L$I = 0   ! It notes whether lines are selected.
show/desc {p1} equiv* H

if {outputi(1)} .ge. 1 then
   write/sms "{smslinesavail}"
   set/midas output=yes
   show/desc {p1} equiv*   >desc.asc
   set/midas output={smsverb}
   $$grep -e name  desc.asc | sed s/name\:\ // | sed s/\(\.*\)// | sed s/\ //g | sed s/EQUIV//
   inquir/keyw eqline "{lineselask}"
   deqline = "EQUIV{eqline}"
   if m$len(eqline) .gt. 0 L$L$L$I = 1 
endif

write/sms "{markask}"
set/gcurs ? cross
get/gcurs ? ? 1
lcoord(1) = {outputr(1)}
lcoord(2) = {outputr(2)}

plot/axes {plrgrap(1)},{plrgrap(2)},{plrgrap(3)},{plrgrap(4)} {plrgrap(5)},{plrgrap(6)},{plrgrap(7)},{plrgrap(8)}  ? "Wavelength (\AA )" "{ylabel}"

overplot/row {p1}

if L$L$L$I .eq. 1 then
   set/graph colour=2 lwidth=3
   over {p1} 1 {{p1},{deqline}(2)},{{p1},{deqline}(3)}
   overplot/line 2 {{p1},{deqline}(2)},{{p1}[{{p1},{deqline}(2)}]} {{p1},{deqline}(3)},{{p1}[{{p1},{deqline}(3)}]}
   set/graph colour=1 lwidth=1
   copy/keyw oldplg/r/1/40 plrgrap/r/1/40
endif

lstep = plrgrap(8) * 1.5 * fsize
label/graph "Object : {smsobject}" {lcoord(1)},{lcoord(2)} ? {fsize} 1
lcoord(2) = {lcoord(2)} - lstep
set/form f20.5

if m$existd(p1,"JD") .eq. 1 then
   label/graph "JD\ \ \ \ \ : {{p1},JD}" {lcoord(1)},{lcoord(2)} ? {fsize} 1
endif

set/form
lcoord(2) = {lcoord(2)} - lstep
if m$existd("{p1}","CIV-DATE") .eq. 1 then
   label/graph "Civil Date : {{p1},CIV-DATE}" {lcoord(1)},{lcoord(2)} ? {fsize} 1
   lcoord(2) = {lcoord(2)} - lstep
endif
if m$existd("{p1}","{deqline}") .eq. 1 then
   set/form f6.2,
   label/graph "EQ({eqline}) : {{p1},{deqline}(1)}\AA \ in [{{p1},{deqline}(2)}, {{p1},{deqline}(3)}]" {lcoord(1)},{lcoord(2)} ? {fsize} 1
   lcoord(2) = {lcoord(2)} - lstep
endif
if m$existd("{p1}","sigtonoise") .eq. 1 then
   set/form i1
   L$L$L$I = {{p1},sigtonoise(1)}
   label/graph "S/N \ \ \ \ : {L$L$L$I} in [{{p1},sigtonoise(2)},{{p1},sigtonoise(3)}]" {lcoord(1)},{lcoord(2)} ? {fsize} 1
   lcoord(2) = {lcoord(2)} - lstep
endif
if m$existd("{p1}","resol") .eq. 1 then
   set/form i1
   label/graph "Mean Resolution : {{p1},resol(3)}" {lcoord(1)},{lcoord(2)} ? {fsize} 1
   lcoord(2) = {lcoord(2)} - lstep
endif
if "{smsobserver}" .ne. "+" then
   label/graph "Observer  : {smsobserver}" {lcoord(1)},{lcoord(2)} ? {fsize} 1
   lcoord(2) = {lcoord(2)} - lstep
endif
if "{smsownstring}" .ne. "+" then
   label/graph "{smsownstring}" {lcoord(1)},{lcoord(2)} ? {fsize} 1
   lcoord(2) = {lcoord(2)} - lstep
endif
