! Time-stamp: <2011-01-01 13:24:00 guenter>

! smsterrestric.prg

define/para p1 {smsresult} ?  "Spectrum: "

if p1 .eq. "-h" then
   @@ sms/help/terrestrichelp.prg
   return
endif

define/para p2 "<,>" ?  "Range: "
define/para p3  + ?  "Wavelength and intensity ranges: "


define/local newaction/c/1/4 "+"
define/local w/i/1/1 1
define/local h/i/1/1 1
define/local start/d/1/1 
define/local end/d/1/1
define/local lrange/r/1/1
define/local rrange/r/1/1
define/local urange/r/1/1
define/local drange/r/1/1
define/local width/r/1/1 0.01
define/local pstart/d/1/1 0.01
define/local sstep/d/1/1 0.01
define/local volve/c/1/1 "0"
define/local num/c/1/3 "1"
define/local offset/r/1/1 0


delete/graph * >/dev/null

set/graph xa=auto ya=auto pm=1 colour=1

start = {{p1},start}
end = {start} + {{p1},step} * {{p1},npix}


lrange = {start}
rrange = {end}

find/minm {p1} >/dev/null
drange = {outputr(1)}
urange = {outputr(2)}

if m$exist("absterr.bdf") .ne. 1 then
   write/sms "Importing absterr.bdf ..." green
   -copy $MID_WORK/sms/smsabsterr.fits absterr.fits
   indisk/fits absterr.fits absterr.bdf
   delete/image absterr.fits no
endif


! we need terraline as input and terrashow as result of convolution
extract/image &terraline = absterr [{start}:{end}]
copy/ii &terraline &terrashow
copy/ii &terraline &cleanspec
width = {&terraline,step} / 2


create/graph 1
! just a little joke
w = {ididev(32)}+3
h = {ididev(33)}-3
create/graph 2 {w},{h}

! show original spectrum
rubbout:
assign/graph G,1
set/graph colour=1
plot/row {p1} 1 {p2}

! choose a smaller region
if p3(1:1) .eq. "+" then 
  write/sms "{rectangle}" cyan
  range:
  get/gcurs middummrect,TABLE N 2 >/dev/null
  if {middummrect.tbl,tblcontr(10)} .eq. 2 then
     statistics/table middummrect :X_AXIS
     lrange = {outputr(1)}
     rrange = {outputr(2)}
     statistics/table middummrect :Y_AXIS
     drange = {outputr(1)}
     urange = {outputr(2)}
     overplot/line 1 {lrange},{urange} {rrange},{urange}
     overplot/line 1 {lrange},{urange} {lrange},{drange}
     overplot/line 1 {rrange},{urange} {rrange},{drange}
     overplot/line 1 {lrange},{drange} {rrange},{drange}
     goto range
  endif
else

endif

write/sms " "
write/sms "{terrbartop}" cyan
write/sms "{terrpm}" cyan
write/sms "{terrlr}" cyan
write/sms "{terrbs}" cyan
write/sms "{terrwn}" cyan
write/sms "{terrq}" cyan
write/sms "{terrbarbottom}" cyan
write/sms " "

align:
set/graph xa={lrange},{rrange}
set/graph ya={drange},{urange} pm=1


! plot selected region
assign/graph G,1
set/graph colour=1
plot/row {p1}
! set/graph colour=4
overplot/row {p1}  ? ? ? ? <,> 4

! overplot computed terrestric lines
! set/graph colour=2
offset = 0.05 * drange + 0.95 * urange - 1

overplot/row &terrashow  ? ? {offset} ? <,> 2
sstep = {&terraline,step}


num = "1"
newaction = newaction(1:1)
inquire/keyw newaction "{newaction}? :"

if m$strlen("{newaction}") .gt. 1 then
   num = newaction(2:>)
   if m$tstno(num) .ne. 1 then
      num = "1"
  endif
endif

branch newaction(1:1) +,-,r,l,w,n,b,s,q more,less,right,left,wider,narrower,broader,smaller,finis
goto rubbout

! enlarge line strength
more:
  compute/image &terraline = 1.0 - 1.1**{num} * (1.0 - &terraline)  
  goto show

! reduce line strength
less: 
  compute/image &terraline = 1.0 - 0.91**{num} * (1.0 - &terraline)
  goto show

! shift lines to the red
right:
  &terraline,start = {&terraline,start} + {&terraline,step}*{num}
  goto show

! shift lines to the blue
left:
  &terraline,start = {&terraline,start} - {&terraline,step}*{num}
  goto show

! enlarge step in terralines
wider:
  &terraline,step = {sstep} * 1.001**{num}
  &terraline,start = {lrange} - ({lrange} - {&terraline,start})/{sstep}*{&terraline,step}
  goto show

! reduce step in terralines
narrower:
  &terraline,step = {sstep} / (1.001**{num})
  &terraline,start = {lrange} - ({lrange} - {&terraline,start})/{sstep}*{&terraline,step}
  goto show

! convolve with growing psf
broader:
   width = {width} * 1.1**{num}
   volve = "c"
   goto show

! convolve with shrinking psf
smaller:
   width = {width} / (1.1**{num})
   if width .lt. 0.01 width = 0.01
   volve = "c"
   goto show

! compute the cleaned spectrum
show:
  copy/ii &terraline &terrashow
  set/form ,f30.20 ,e30.20      ! necessary for a well centered psf
  sstep = m$value(&terraline,step)
  !  Always convole shifted, stretched, enlarged, etc. spectrum middummterraline.bdf
  !  with current width. 
  if volve .eq. "c"   then
     pstart = -127.5*{sstep}
     create/image psf 1,256 {pstart},{sstep} gauss 0.0,{width}
     center/gauss psf >/dev/null
     compute/keyw L$L$L$D = m$value(psf,start) - {outputd(5)}
     psf,start = {L$L$L$D}
     convolve/image &terraline psf &terrashow
  endif

  set/form
  rebin/line  &terrashow &terrareb {{p1},step}
  compute/image &cleanspec = {p1} / &terrareb
  assign/graph G,2
  set/graph xa={lrange},{rrange}
  set/graph ya={drange},{urange} 
  set/graph colour=1 pm=1
  plot/row &cleanspec
goto align

finis:

delete/graph 2
assign/graph G,1
set/graph ya=auto xa={lrange},{rrange} pm=1 colour=1
plot/row {p1}
set/graph colour=2
overplot/row {p1}
label/graph "Original" 0.2,0.3,no ? ? 1
set/graph colour=1
set/form f4.0
extract/image {p1}_clean_{lrange}to{rrange} = &cleanspec [{lrange}:{rrange}]
overplot/row {p1}_clean_{lrange}to{rrange}
label/graph "{cleaned}" 0.2,0.2,no ? ? 1
outdisk/fits {p1}_clean_{lrange}to{rrange} {p1}_clean_{lrange}to{rrange}.fits
write/sms " --> {p1}_clean_{lrange}to{rrange}.bdf" green
write/sms " --> {p1}_clean_{lrange}to{rrange}.fits" green
set/form
set/graph xaxis=auto yaxis=auto
